#!/usr/bin/perl


#  Copyright (C) 2003  Maik Schmitt - <maik@graphics.cs.uni-sb.de>
#  
#  This script is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#  
#  It is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#  
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



use DBI qw(:sql_types);

(-e '/var/lock/md5pws') and die "Lock file found!";

system("touch /var/lock/md5pws");

$databaseName = "DBI:mysql:asterisk";
$databaseUser = "";
$databasePw = "";

$dbh = DBI->connect($databaseName, $databaseUser, 
    $databasePw) || die "Connect failed: $DBI::errstr\n";
unless (open SOURCE, "<", "/etc/asterisk/sip.conf") {
    die "Couldn't open sip.conf";
}
unless (open DEST, ">", "/tmp/md5pws") {
    die "Couldn't open tempfile";
}

$changed = false;

while (<SOURCE>) {
    if(/^md5secret=.*;.*$/) {
	$line = $_;
	($a, $b) = split /=/, $line;
	($hash, $user) = split /;/, $b;
	chomp($user);
	$stmt = "SELECT hash FROM sipusers WHERE (user='$user')";
	$sth = $dbh->prepare($stmt) || die "prepare: $$stmt: $DBI::errstr";
	$sth->execute || die "execute: $$stmt: $DBI::errstr";
	@record = $sth->fetchrow();
	$newhash = $record[0];
	$sth->finish();

	if ( $newhash ) {
	    if ( $newhash =~ $hash ) {
		print DEST $_;
	    }
	    else {
		$changed = true;
		print DEST "md5secret=$newhash;$user\n";
	    }
	}
	else {
	    print DEST $_;
	}
    }
    else {
	print DEST $_;
    }
}

$dbh->disconnect();

if ( $changed =~ true ) {
    system("mv /tmp/md5pws /etc/asterisk/sip.conf");
    system("/usr/sbin/asterisk -rx reload >/dev/null 2>&1");
}

unlink("/var/lock/md5pws");
